=== debian/changelog ===
victoriametrics (1.53.1+ds-1) unstable; urgency=medium

  * New upstream release.
    - Imports vmctl tool.

 -- Guillem Jover <gjover@sipwise.com>  Mon, 08 Feb 2021 23:15:20 +0100

victoriametrics (1.52.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Move note about license location on Debian systems into a Comment field.
  * Switch from /var/run to /run.
  * Fix coding style in init script.
  * Use '' instead of unbalanced `' in text.
  * Ignore test suite errors on non-amd64,i386,armel due to floating point
    checks missing epsilon handling in comparison.

 -- Guillem Jover <gjover@sipwise.com>  Tue, 26 Jan 2021 23:41:54 +0100

victoriametrics (1.51.0+ds-3) unstable; urgency=medium

  * Mark packages as Multi-Arch:foreign.
  * Update option documentation in default file.
  * Update copyright years.

 -- Guillem Jover <gjover@sipwise.com>  Wed, 06 Jan 2021 01:59:31 +0100

victoriametrics (1.51.0+ds-2) unstable; urgency=medium

  * Rename DAEMON_ARGS to ARGS in default file to match other prometheus
    packages.

 -- Guillem Jover <gjover@sipwise.com>  Tue, 05 Jan 2021 19:56:47 +0100

victoriametrics (1.51.0+ds-1) unstable; urgency=medium

  * New upstream release.
    - Bump golang-github-victoriametrics-metricsql-dev Build-Depends to 0.9.1.

 -- Guillem Jover <gjover@sipwise.com>  Mon, 28 Dec 2020 18:18:00 +0100

victoriametrics (1.50.1+ds-1) unstable; urgency=medium

  * Initial release (Closes: #953666)

 -- Guillem Jover <gjover@sipwise.com>  Thu, 17 Dec 2020 02:02:05 +0100
